diff -Nru WRFV3.5/phys/module_sf_clm.F WRFV3.5_MR/phys/module_sf_clm.F
--- WRFV3.5/phys/module_sf_clm.F	2013-04-17 17:12:47.000000000 +0200
+++ WRFV3.5_MR/phys/module_sf_clm.F	2014-12-17 11:53:55.877462524 +0100
@@ -870,22 +870,26 @@
 ! (18) lava
 ! (19) white-sand
 !----------------------------------------------------------------------------
-  data (plant(i,1),i=1,24) / 0,  15,  15,  15,  15,  15, &
-                            14,   9,   9,  14,   7,   3, &
-                             4,   1,   1,   0,   0,   4, &
+
+!cmr: change settings for plant types: 
+! discard plant types 1-6 and define own plant types!
+! i just want to use single pft 13,12,1,3,5 and 8
+  data (plant(i,1),i=1,24) / 1,   2,   3,   4,   5,   6, &
+                             7,   8,   9,  10,  11,  12, &
+                            13,  14,  15,  16,   0,   4, &
                             11,  11,   2,  11,  11,   0/
-  data (cover(i,1),i=1,24) /100.,  85.,  85.,  85.,  50.,  40., &
-                             60.,  80.,  50.,  70.,  75.,  50., &
-                             95.,  75.,  37., 100., 100.,  80., &
+  data (cover(i,1),i=1,24) /100., 100., 100., 100., 100., 100., &
+                            100., 100., 100., 100., 100., 100., &
+                            100., 100., 100., 100., 100.,  80., &
                              10.,  30.,  13.,  20.,  10., 100./
 
-  data (plant(i,2),i=1,24) / 0,   0,   0,   0,  14,   3, &
-                            13,   0,  14,   6,   0,   0, &
-                             0,   0,   7,   0,   0,   0, &
+  data (plant(i,2),i=1,24) / 0,   0,   0,   0,   0,   0, &
+                             0,   0,   0,   0,   0,   0, &
+                             0,   0,   0,   0,   0,   0, &
                              0,  12,   3,  12,  12,   0/
-  data (cover(i,2),i=1,24) /  0.,  15.,  15.,  15.,  35.,  30., &
-                             20.,  20.,  30.,  30.,  25.,  50., &
-                              5.,  25.,  37.,   0.,   0.,  20., &
+  data (cover(i,2),i=1,24) /  0.,   0.,   0.,   0.,   0.,   0., &
+                              0.,   0.,   0.,   0.,   0.,   0., &
+                              0.,   0.,   0.,   0.,   0.,   0., &
                              90.,  30.,  13.,  20.,  10.,   0./
 
   data (plant(i,3),i=1,24) / 0,   0,   0,   0,   0,   0, &
@@ -893,9 +897,9 @@
                              0,   0,   0,   0,   0,   0, &
                              0,   0,  10,   0,   0,   0/
 
-  data (cover(i,3),i=1,24) /  0.,   0.,   0.,   0.,  15.,  30., &
-                             20.,   0.,  20.,   0.,   0.,   0., &
-                              0.,   0.,  26.,   0.,   0.,   0., &
+  data (cover(i,3),i=1,24) /  0.,   0.,   0.,   0.,   0.,   0., &
+                              0.,   0.,   0.,   0.,   0.,   0., &
+                              0.,   0.,   0.,   0.,   0.,   0., &
                               0.,  40.,  24.,  60.,  80.,   0./
 
   data (plant(i,4),i=1,24) / 0,   0,   0,   0,   0,   0, &
@@ -948,33 +952,47 @@
 
 
     data (lai(1,i),i=1,12) &
-        /4.1,4.2,4.6,4.8,4.9,5.0,4.8,4.7,4.6,4.2,4.0,4.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr set LAI all equal        /4.1,4.2,4.6,4.8,4.9,5.0,4.8,4.7,4.6,4.2,4.0,4.0/
     data (lai(2,i),i=1,12) &
-        /4.1,4.2,4.6,4.8,4.9,5.0,4.8,4.7,4.6,4.2,4.0,4.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr set LAI all equal        /4.1,4.2,4.6,4.8,4.9,5.0,4.8,4.7,4.6,4.2,4.0,4.0/
     data (lai(3,i),i=1,12) &
         /0.0,0.0,0.0,0.6,1.2,2.0,2.6,1.7,1.0,0.5,0.2,0.0/
     data (lai(4,i),i=1,12) &
-        /4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5/
     data (lai(5,i),i=1,12) &
-        /4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5,4.5/
     data (lai(6,i),i=1,12) &
-        /0.8,0.7,0.4,0.5,0.5,0.7,1.7,3.0,2.5,1.6,1.0,1.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.8,0.7,0.4,0.5,0.5,0.7,1.7,3.0,2.5,1.6,1.0,1.0/
     data (lai(7,i),i=1,12) &
-        /0.0,0.0,0.3,1.2,3.0,4.7,4.5,3.4,1.2,0.3,0.0,0.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.0,0.0,0.3,1.2,3.0,4.7,4.5,3.4,1.2,0.3,0.0,0.0/
     data (lai(8,i),i=1,12) &
-        /0.0,0.0,0.3,1.2,3.0,4.7,4.5,3.4,1.2,0.3,0.0,0.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.0,0.0,0.3,1.2,3.0,4.7,4.5,3.4,1.2,0.3,0.0,0.0/
     data (lai(9,i),i=1,12) &
-        /1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0/
     data (lai(10,i),i=1,12) &
-        /0.9,0.8,0.2,0.2,0.0,0.0,0.0,0.2,0.4,0.5,0.6,0.8/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.9,0.8,0.2,0.2,0.0,0.0,0.0,0.2,0.4,0.5,0.6,0.8/
     data (lai(11,i),i=1,12) &
-        /0.0,0.0,0.0,0.0,0.0,0.2,1.4,1.2,0.0,0.0,0.0,0.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.0,0.0,0.0,0.0,0.0,0.2,1.4,1.2,0.0,0.0,0.0,0.0/
     data (lai(12,i),i=1,12) &
-        /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr        /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
     data (lai(13,i),i=1,12) &
-        /0.0,0.0,0.0,0.0,0.0,0.2,1.4,1.2,0.0,0.0,0.0,0.0/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr       /2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0,2.0/
+!cmr set LAI all equal        /0.0,0.0,0.0,0.0,0.0,0.2,1.4,1.2,0.0,0.0,0.0,0.0/
     data (lai(14,i),i=1,12) &
-        /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
+        /4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0,4.0/
+!cmr set LAI all equal        /0.4,0.5,0.6,0.7,1.2,3.0,3.5,1.5,0.7,0.6,0.5,0.4/
     data (lai(15,i),i=1,12) &
         /0.0,0.0,0.0,0.0,1.0,2.0,3.0,3.0,1.5,0.0,0.0,0.0/
     data (lai(16,i),i=1,12) &
@@ -1419,6 +1437,7 @@
    real(r8), pointer :: dewmx(:)                !Maximum allowed dew [mm]
    real(r8), pointer :: rssun(:)                !sunlit stomatal resistance (s/m)
    real(r8), pointer :: rssha(:)                !shaded stomatal resistance (s/m)
+   real(r8), pointer :: rs_mr(:)                !shaded stomatal resistance (s/m) for export !cmr
    real(r8), pointer :: laisun(:)               !sunlit projected leaf area index
    real(r8), pointer :: laisha(:)               !shaded projected leaf area index
    real(r8), pointer :: btran(:)                !transpiration wetness factor (0 to 1)
@@ -1495,6 +1514,14 @@
    ! Adding isotope code
    real(r8), pointer :: cisun(:)       !sunlit intracellular CO2 (Pa)
    real(r8), pointer :: cisha(:)       !shaded intracellular CO2 (Pa)
+   real(r8), pointer :: ci_mr(:)       !shaded intracellular CO2 (Pa) for export !cmr
+   real(r8), pointer :: rb_mr(:)       ! !cmr
+   real(r8), pointer :: btran_mr(:)       ! !cmr
+   real(r8), pointer :: apar_mr(:)       ! !cmr
+   real(r8), pointer :: sla_mr(:)       ! !cmr
+   real(r8), pointer :: vcmx_mr(:)       ! !cmr
+   real(r8), pointer :: svpts_mr(:)       ! !cmr
+   real(r8), pointer :: eah_mr(:)       ! !cmr
 #if (defined C13)
    real(r8), pointer :: alphapsnsun(:) !sunlit 13c fractionation ([])
    real(r8), pointer :: alphapsnsha(:) !shaded 13c fractionation ([])
@@ -1995,7 +2022,31 @@
    real(r8), pointer :: psnsun(:)         !sunlit leaf photosynthesis (umol CO2 /m**2/ s)
    real(r8), pointer :: psnsha(:)         !shaded leaf photosynthesis (umol CO2 /m**2/ s)
    real(r8), pointer :: fpsn(:)           !photosynthesis (umol CO2 /m**2 /s)
-   real(r8), pointer :: fco2(:)           !net CO2 flux (umol CO2 /m**2 /s) [+ = to atm]
+!cmr define more variables 
+   real(r8), pointer :: psnsun2(:)         !sunlit leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: psnsha2(:)         !shaded leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: fpsn_mn(:)           !photosynthesis (umol CO2 /m**2 /s)
+   real(r8), pointer :: psnsun3(:)         !sunlit leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: psnsun4(:)         !sunlit leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: psnsha3(:)         !shaded leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: psnsha4(:)         !shaded leaf photosynthesis (umol CO2 /m**2/ s)
+   real(r8), pointer :: fpsn_mx(:)           !photosynthesis (umol CO2 /m**2 /s)
+   real(r8), pointer :: fpsn_nf(:)           !photosynthesis (umol CO2 /m**2 /s)
+   real(r8), pointer :: wc(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wj(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: we(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wcsun(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wjsun(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wesun(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wcsha(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wjsha(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wesha(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: reco(:)           !respiration CO2 flux (umol CO2 /m**2 /s) [+ =to atm]
+   real(r8), pointer :: reco_gpp(:)           !respiration CO2 flux (umol CO2 /m**2 /s) [+ =to atm]
+   real(r8), pointer :: reco_gppmn(:)           !respiration CO2 flux (umol CO2 /m**2 /s) [+ =to atm]
+   real(r8), pointer :: reco_gppmx(:)           !respiration CO2 flux (umol CO2 /m**2 /s) [+ =to atm]
+   real(r8), pointer :: fpsn_noslp(:)           !photosynthesis (umol CO2 /m**2 /s)
+!cmr end
    ! new variables for CN code
    ! gap mortality fluxes
    real(r8), pointer :: m_leafc_to_litter(:)                 ! leaf C mortality (gC/m2/s)
@@ -3741,7 +3792,10 @@
   use clm_varcon, only: hvap, hsub,tfrz, vkc, sb  ,&
                         snowage_drdt0,ndep,organic,fmax,efisop
   use module_cam_support, only: endrun
-  
+!cmr use namelist parameters 
+  USE module_configure, only: grid_config_rec_type
+!cmr end
+ 
 !
 CONTAINS
 !
@@ -3842,13 +3896,16 @@
                 ,dwt_frootn_to_litr1n,dwt_frootn_to_litr2n, dwt_frootn_to_litr3n &
                 , dwt_livecrootn_to_cwdn,dwt_deadcrootn_to_cwdn,retransn &
 #endif
-                 )
+                ,fco2,fco2mn,fco2mx,fco2nf,reco,reco_gpp,reco_gppmn,reco_gppmx,fpsn,fpsn_mn,fpsn_mx,fpsn_nf,fpsn_noslp & 
+                ,co2_clm,co2_clm2,co2_clm3,wj,we,wc,ci_mr,rs_mr, &
+                rb_mr,btran_mr,apar_mr,sla_mr,vcmx_mr,svpts_mr,eah_mr,slope  & !cmr 
+                ,valley_CO2pft2,valley_CO2backgr & !cmr  
+              )
 
 
   USE module_date_time
   USE module_sf_urban, only: urban
   USE module_configure
-
   implicit none
 
   integer,  intent(in)       ::     ids,ide, jds,jde, kds,kde,  &
@@ -3872,7 +3929,7 @@
                    ,canwat     ,acsnom     ,acsnow,   emiss, z0
 
   real,dimension(ims:ime,jms:jme ),intent(in) ::&
-                 vegfra, tmn,shdmin,shdmax
+                 vegfra, tmn,shdmin,shdmax,slope !cmr added slope
 
   real,dimension(ims:ime,jms:jme ),intent(in) ::&
                    qgh,chs,chs2
@@ -3881,6 +3938,12 @@
   logical :: found = .false.
   integer,   dimension(ims:ime,jms:jme ),intent(inout) :: numc,nump
   real,  dimension(ims:ime,jms:jme ),intent(inout) :: soiflx,sabv,sabg,lwup,t2m_max,t2m_min
+  real,  dimension(ims:ime,jms:jme ),intent(out) :: reco,reco_gpp,reco_gppmn,reco_gppmx,fpsn,fpsn_mn,fpsn_mx,fpsn_nf,fpsn_noslp,wj,we,wc, &
+                                                    ci_mr,rs_mr,rb_mr,btran_mr,apar_mr,sla_mr,vcmx_mr,svpts_mr,eah_mr !cmr
+  real,  dimension(ims:ime,jms:jme ),intent(out) :: fco2,fco2mn,fco2mx,fco2nf !cmr
+  REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(IN ) :: co2_clm,co2_clm2,co2_clm3 !cmr
+  INTEGER :: valley_CO2pft2 !cmr
+  REAL :: valley_CO2backgr !cmr
   integer,  dimension(ims:ime,1:maxpatch,jms:jme ) :: snl,snl1
   real,  dimension(ims:ime,1:maxpatch,jms:jme ),intent(inout) ::  &
                 snowdp,wtc,wtp,h2osno,t_grnd,t_veg,         &
@@ -3993,6 +4056,27 @@
   real(r8) :: qdnxy_buf
   real(r8) :: soiflx_buf
   real(r8) :: sabv_buf
+  real(r8) :: fpsn_buf !cmr
+  real(r8) :: fpsn_mn_buf !cmr
+  real(r8) :: fpsn_mx_buf !cmr
+  real(r8) :: fpsn_nf_buf !cmr
+  real(r8) :: reco_buf !cmr
+  real(r8) :: reco_gpp_buf !cmr
+  real(r8) :: reco_gppmn_buf !cmr
+  real(r8) :: reco_gppmx_buf !cmr
+  real(r8) :: wj_buf !cmr
+  real(r8) :: we_buf !cmr
+  real(r8) :: wc_buf !cmr
+  real(r8) :: ci_buf !cmr
+  real(r8) :: rs_buf !cmr
+  real(r8) :: rb_buf !cmr
+  real(r8) :: btran_buf !cmr
+  real(r8) :: apar_buf !cmr
+  real(r8) :: sla_buf !cmr
+  real(r8) :: vcmx_buf !cmr
+  real(r8) :: svpts_buf !cmr
+  real(r8) :: eah_buf !cmr
+  real,dimension(4) :: atm_co2 !cmr
   real(r8) :: sabg_buf
   real(r8) :: lwup_buf
   real(r8) :: znt_buf
@@ -4221,7 +4305,7 @@
  character*256 :: msg
  real :: mh_urb,stdh_urb,lp_urb,hgt_urb,frc_urb,lb_urb,check
  real, dimension(4) :: lf_urb
- 
+
 ! ----------------------------------------------------------------------
    call clm_varpar_mod
 
@@ -4272,9 +4356,6 @@
   mbdate = myrs*10000 + mons*100 + mdays
 
 
-!write(6,*) 'at nstep=',nstep,'snowage_drdt0(1,31,8)=',snowage_drdt0(1,31,8)
-
-
   do j=jts,jte
 
    do i=its,ite
@@ -4283,9 +4364,9 @@
       else
         lndmsk = 0
       end if
-
   
-    if(lndmsk == 1) then
+
+      if(lndmsk == 1) then
       qsfxy_buf       = qsfxy(i,j)
       qdnxy_buf       = qdnxy(i,j)
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -4319,7 +4400,11 @@
       forc_txy_buf   = forc_txy(i,1,j)
       forc_uxy_buf   = forc_uxy(i,1,j)
       forc_vxy_buf   = forc_vxy(i,1,j)
-      forc_qxy_buf   = forc_qxy(i,1,j)
+!cmr wind set to constant value
+!      forc_uxy_buf   = 5.  !forc_uxy(i,1,j)
+!      forc_vxy_buf   = 0.  !forc_vxy(i,1,j)
+!cmr end
+      forc_qxy_buf   = forc_qxy(i,1,j)/(1.0+forc_qxy(i,1,j)) !cmr bugfix in wrf3.5.1
       zgcmxy_buf     = zgcmxy(i,1,j)
       prec_buf       = prec(i,j)/dtt ! mm/s
       flwdsxy_buf    = flwdsxy(i,j)
@@ -4340,7 +4425,43 @@
       sabv_buf       = 0.0
       sabg_buf       = 0.0
       lwup_buf       = 0.0
-
+!cmr begin
+      fpsn(i,j) = 0.0   
+      fpsn_mn(i,j) = 0.0   
+      fpsn_mx(i,j) = 0.0   
+      fpsn_nf(i,j) = 0.0   
+      fpsn_noslp(i,j) = 0.0   
+      fco2(i,j) = 0.0
+      fco2mn(i,j) = 0.0
+      fco2mx(i,j) = 0.0
+      fco2nf(i,j) = 0.0
+      reco(i,j) = 0.0
+      reco_gpp(i,j) = 0.0
+      reco_gppmn(i,j) = 0.0
+      reco_gppmx(i,j) = 0.0
+      wj(i,j) = 0.0
+      we(i,j) = 0.0
+      wc(i,j) = 0.0 
+      ci_mr(i,j) = 0.0
+      rs_mr(i,j) = 0.0
+! rb_mr,btran_mr,apar_mr,sla_mr,vcmx_mr
+      rb_mr(i,j) = 0.0
+      btran_mr(i,j) = 0.0
+      apar_mr(i,j) = 0.0
+      sla_mr(i,j) = 0.0
+      vcmx_mr(i,j) = 0.0
+      svpts_mr(i,j) = 0.0
+      eah_mr(i,j) = 0.0
+      fpsn_buf = 0.0      
+      fpsn_mn_buf = 0.0      
+      fpsn_mx_buf = 0.0      
+      fpsn_nf_buf = 0.0      
+      reco_buf = 0.0
+      reco_gpp_buf = 0.0
+      reco_gppmn_buf = 0.0
+      reco_gppmx_buf = 0.0
+!cmr end
+    
      swvisdir_buf = swvisdir(i,j)
      swvisdif_buf = swvisdif(i,j)
      swnirdir_buf = swnirdir(i,j)
@@ -4457,14 +4578,27 @@
 
       t_grnd_buf(m)     = t_grnd(i,m,j)
       t_veg_buf(m)      = t_veg(i,m,j)
+!cmr: the following variables are not initializedwith canwat, it could be done manually further
+!     down in clminit  
       h2ocan_buf(m)     = h2ocan(i,m,j)
       h2ocan_col_buf(m) = h2ocan_col(i,m,j)
       h2osno_buf(m)     = h2osno(i,m,j)
+!cmr
       albedosubgrid_buf(m) = albedosubgrid(i,m,j)
       lhsubgrid_buf(m)  = lhsubgrid(i,m,j)
       hfxsubgrid_buf(m) = hfxsubgrid(i,m,j)
       lwupsubgrid_buf(m)= lwupsubgrid(i,m,j)
       q2subgrid_buf(m)  = q2subgrid(i,m,j)
+
+
+!cmrwrite
+!   write(msg,*) 'cmr: before clm:',t_grnd(i,m,j),t_veg(i,m,j),h2ocan(i,m,j)
+!   CALL CLMDebug(msg)
+!   write(msg,*) h2ocan_col(i,m,j),h2osno(i,m,j),albedosubgrid(i,m,j)
+!   CALL CLMDebug(msg)
+!   write(msg,*) lhsubgrid(i,m,j),hfxsubgrid(i,m,j),lwupsubgrid(i,m,j),q2subgrid(i,m,j)
+!   CALL CLMDebug(msg)
+
 !ylu 01/14/09
       sabvsubgrid_buf(m) = sabvsubgrid(i,m,j)
       sabgsubgrid_buf(m) = sabgsubgrid(i,m,j)
@@ -4624,8 +4758,20 @@
       retransn_buf(m)               = retransn(i,m,j)
 #endif
     end do !!!!!!!!!!!!!!!!! m=1, maxpatch
-       
-   !  if(lndmsk  == 1) then
+
+!cmr: need to link CO2_BIO (=co2_clm) from wrf chem to CLM here
+      atm_co2(1) = co2_clm(i,1,j)*1e-06 ! CO2 concentration with feedback 
+      atm_co2(2) = co2_clm2(i,1,j)*1e-06 ! CO2 concentration highest gpp and lowest reco 
+      atm_co2(3) = co2_clm3(i,1,j)*1e-06 ! CO2 concentration lowest gpp and highest reco 
+      atm_co2(4) = valley_CO2backgr*1e-06 ! no feedback, using background concentration here 
+   write(msg,*) 'atm_co2(1)=',atm_co2(1),'atm_co2(2)=',atm_co2(2),'atm_co2(3)=',atm_co2(3)
+   CALL CLMDebug(msg)
+!   write(msg,*) 'valley_CO2backgr=',valley_CO2backgr
+!   CALL wrf_debug(0,msg)
+!cmr end 
+
+     
+    ! if(lndmsk  == 0) then 
 
           call clm(forc_txy_buf        ,forc_uxy_buf           ,forc_vxy_buf    &
                   ,forc_qxy_buf        ,zgcmxy_buf             ,prec_buf        &
@@ -4690,8 +4836,14 @@
                 ,dwt_frootn_to_litr1n_buf,dwt_frootn_to_litr2n_buf, dwt_frootn_to_litr3n_buf &
                 , dwt_livecrootn_to_cwdn_buf,dwt_deadcrootn_to_cwdn_buf,retransn_buf &                                                 
 #endif
-                  )
+                ,fpsn_buf,fpsn_mn_buf,fpsn_mx_buf,fpsn_nf_buf,reco_buf,reco_gpp_buf,reco_gppmn_buf,reco_gppmx_buf & 
+                ,atm_co2,wj_buf,we_buf,wc_buf,ci_buf,rs_buf  & !cmr
+                ,rb_buf,btran_buf,apar_buf,sla_buf,vcmx_buf,svpts_buf,eah_buf  )
                  
+!cmrwrite
+   write(msg,*) 'cmr: after clm: maxval(smois)',smois(i,j),'canwat',canwat(i,j)
+   CALL CLMDebug(msg)
+
                  if(albxy_buf ==  1) albxy_buf = 0.991
 
                   albxy(i,j)          = albxy_buf
@@ -4708,14 +4860,19 @@
                      tslb (i,k,j)     = sum(t_soisno_buf(1:numc(i,j),k)*wtc_buf(1:numc(i,j)))
                   end do !over levels
               end if
-                  call CLMDebug('get tslb')
+
+!cmrwrite
+   write(msg,*) 'cmr: after clm: maxval(smois)',smois(i,j),'canwat',canwat(i,j)
+   CALL CLMDebug(msg)
+
+   call CLMDebug('get tslb')
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
                   tsxy(i,j)           = tsxy_buf
                   qsfxy(i,j)          = qsfxy_buf
                   qdnxy(i,j)          = qdnxy_buf
                   soiflx(i,j)         = soiflx_buf
-                  sabv(i,j)           = sabv_buf
+                  sabv(i,j)           = sabv_buf 
                   sabg(i,j)           = sabg_buf
                   lwup(i,j)           = lwup_buf
                   znt(i,j)            = znt_buf
@@ -4726,6 +4883,35 @@
                   alswnirdif(i,j)     = alswnirdif_buf
 
                   t2clm(i,j)       = trefxy_buf
+
+!cmr write out photosynthesis
+                  fpsn(i,j)           = fpsn_buf*(1/cos(slope(i,j)))
+                  fpsn_mn(i,j)          = fpsn_mn_buf*(1/cos(slope(i,j)))
+                  fpsn_mx(i,j)          = fpsn_mx_buf*(1/cos(slope(i,j)))
+                  fpsn_nf(i,j)          = fpsn_nf_buf*(1/cos(slope(i,j)))
+                  fpsn_noslp(i,j)     = fpsn_buf
+                  reco(i,j)           = reco_buf*(1/cos(slope(i,j)))
+                  reco_gpp(i,j)       = reco_gpp_buf*(1/cos(slope(i,j)))
+                  reco_gppmn(i,j)       = reco_gppmn_buf*(1/cos(slope(i,j)))
+                  reco_gppmx(i,j)       = reco_gppmx_buf*(1/cos(slope(i,j)))
+                  fco2(i,j)           = reco_gpp(i,j)-fpsn(i,j) 
+                  fco2mn(i,j)          = reco_gppmn(i,j)-fpsn_mx(i,j) !adding lowest reco and (most negative) max fpsn
+                  fco2mx(i,j)          = reco_gppmx(i,j)-fpsn_mn(i,j) !adding highest reco and (least neg.) min fpsn
+                  fco2nf(i,j)          = reco_gpp(i,j)-fpsn_nf(i,j) 
+                  wj(i,j)             = wj_buf*(1/cos(slope(i,j)))
+                  we(i,j)             = we_buf*(1/cos(slope(i,j)))
+                  wc(i,j)             = wc_buf*(1/cos(slope(i,j)))
+                  ci_mr(i,j)          = ci_buf
+                  rs_mr(i,j)          = rs_buf
+                  rb_mr(i,j)          = rb_buf
+                  btran_mr(i,j)          = btran_buf
+                  apar_mr(i,j)          = apar_buf
+                  sla_mr(i,j)          = sla_buf
+                  vcmx_mr(i,j)          = vcmx_buf
+                  svpts_mr(i,j)          = svpts_buf
+                  eah_mr(i,j)          = eah_buf
+!cmr end
+
 !Accumulate T2 MAX/MIN between history interval --Yaqiong Lu
                   if(mod(dt*(nstep-1),60.*history_interval)==0) then 
                     t2m_max(i,j) = 0.0
@@ -5010,6 +5196,10 @@
 
               end do !!!!!!!!!!!!! m = 1, maxpatch
       end if
+
+      
+
+      
         call CLMDebug('good before call urban')
         IF (sf_urban_physics == 1 ) THEN                                              ! Beginning of UCM CALL if block
 !--------------------------------------
@@ -5198,6 +5388,7 @@
   end do ! of i loop
   end do ! of j loop
 
+
    do i=its,ite
     do j=jts,jte
      do m=1,maxpatch
@@ -5372,6 +5563,8 @@
    LOGICAL                   :: opened
 
    integer                   :: lu_unit
+   
+   character*256 :: msg !cmr 
 
    call CLMDebug('Now in clminit.')
 
@@ -5492,8 +5685,19 @@
 !------------------------------------------------------------------------------
           DO j = jts,jtf
           DO i = its,itf
-
-
+!cmr initialize CLM soil temperature to 10°C and total soil moisture to 1 -> will need to use a realistic T profile
+!              tslb(i,:,j)=283.16 
+!              tslb(i,1,j)=285.8
+!              tslb(i,2,j)=286.1
+!              tslb(i,3,j)=286.6
+!              tslb(i,4,j)=287.0
+!              tslb(i,5,j)=286.7
+!              tslb(i,6,j)=285.1
+!              tslb(i,7,j)=283.7
+!              tslb(i,8,j)=282.1
+!              tslb(i,9,j)=280.4
+!              tslb(i,10,j)=279.5
+!cmr              smois(i,:,j)=0.3 !cmr smois
           if((xland(i,j)-1.5).ge.0.)then
 
              If(xice(i,j).eq.1)print*,' SEA-ICE AT WATER POINT, i=',i,'j=',j
@@ -5717,6 +5921,9 @@
           do j=jts,jtf
               h2ocan(i,:,j) = 0.0
               h2ocan_col(i,:,j) = 0.0
+!cmr initialized canwat but decreased to zero in 2h anyway
+!              h2ocan(i,:,j) = smois(i,:,j)
+!              h2ocan_col(i,:,j) = smois(i,:,j)
               sfcrunoff(i,j) = 0.0 
               udrunoff(i,j) = 0.0
           end do
@@ -5945,6 +6152,14 @@
       end do
       end do
 
+!cmrwrite
+   write(msg,*) 'cmr: in clminit:smois',maxval(smois),'h2osoi_vol1',maxval(h2osoi_vol1),'h2osoi_liq1',maxval(h2osoi_liq1),&
+             'h2osoi_ice1',maxval(h2osoi_ice1),'dzs(1)',dzs(1),'t_soisno1',maxval(t_soisno1)
+   CALL CLMDebug(msg)
+   write(msg,*) 'cmr: in clminit:max_minval(sh2o)',maxval(sh2o),minval(sh2o)
+   CALL CLMDebug(msg)
+!cmr
+
    call CLMDebug('clminit done')
 !------------------------------------------------------------------------------
  END SUBROUTINE clminit
@@ -6282,6 +6497,10 @@
   IMPLICIT NONE
   CHARACTER*(*), str
 
+!cmrwrite uncomment if you need to debug
+CALL wrf_debug(1,str)
+!cmr end
+
 #if (defined DEBUGCLM)
   print*, TRIM(str)
   call flush(6)
@@ -7208,6 +7427,7 @@
     allocate(pps%dewmx(beg:end))
     allocate(pps%rssun(beg:end))
     allocate(pps%rssha(beg:end))
+    allocate(pps%rs_mr(beg:end)) !cmr
     allocate(pps%laisun(beg:end))
     allocate(pps%laisha(beg:end))
     allocate(pps%btran(beg:end))
@@ -7283,6 +7503,14 @@
     ! Adding isotope code
     allocate(pps%cisun(beg:end))
     allocate(pps%cisha(beg:end))
+    allocate(pps%ci_mr(beg:end)) !cmr
+    allocate(pps%rb_mr(beg:end)) !cmr
+    allocate(pps%btran_mr(beg:end)) !cmr
+    allocate(pps%apar_mr(beg:end)) !cmr
+    allocate(pps%sla_mr(beg:end)) !cmr
+    allocate(pps%vcmx_mr(beg:end)) !cmr
+    allocate(pps%svpts_mr(beg:end)) !cmr
+    allocate(pps%eah_mr(beg:end)) !cmr
 #if (defined C13)
     allocate(pps%alphapsnsun(beg:end))
     allocate(pps%alphapsnsha(beg:end))
@@ -7385,6 +7613,7 @@
     pps%dewmx(beg:end) = nan
     pps%rssun(beg:end) = nan
     pps%rssha(beg:end) = nan
+    pps%rs_mr(beg:end) = nan !cmr
     pps%laisun(beg:end) = nan
     pps%laisha(beg:end) = nan
     pps%btran(beg:end) = nan
@@ -7460,6 +7689,14 @@
     ! Adding isotope code
     pps%cisun(beg:end) = nan
     pps%cisha(beg:end) = nan
+    pps%ci_mr(beg:end) = nan !cmr
+    pps%rb_mr(beg:end) = nan !cmr
+    pps%btran_mr(beg:end) = nan !cmr
+    pps%apar_mr(beg:end) = nan !cmr
+    pps%sla_mr(beg:end) = nan !cmr
+    pps%vcmx_mr(beg:end) = nan !cmr
+    pps%svpts_mr(beg:end) = nan !cmr
+    pps%eah_mr(beg:end) = nan !cmr
 #if (defined C13)
     pps%alphapsnsun(beg:end) = nan
     pps%alphapsnsha(beg:end) = nan
@@ -8351,7 +8588,30 @@
     allocate(pcf%psnsun(beg:end))
     allocate(pcf%psnsha(beg:end))
     allocate(pcf%fpsn(beg:end))
-    allocate(pcf%fco2(beg:end))
+    allocate(pcf%psnsun2(beg:end)) !cmr
+    allocate(pcf%psnsun3(beg:end)) !cmr
+    allocate(pcf%psnsun4(beg:end)) !cmr
+    allocate(pcf%psnsha2(beg:end)) !cmr
+    allocate(pcf%psnsha3(beg:end)) !cmr
+    allocate(pcf%psnsha4(beg:end)) !cmr
+    allocate(pcf%fpsn_mn(beg:end)) !cmr
+    allocate(pcf%fpsn_mx(beg:end)) !cmr
+    allocate(pcf%fpsn_nf(beg:end)) !cmr
+    allocate(pcf%fpsn_noslp(beg:end)) !cmr
+!    allocate(pcf%fco2(beg:end))
+    allocate(pcf%reco(beg:end)) !cmr
+    allocate(pcf%reco_gpp(beg:end)) !cmr
+    allocate(pcf%reco_gppmn(beg:end)) !cmr
+    allocate(pcf%reco_gppmx(beg:end)) !cmr
+    allocate(pcf%wj(beg:end)) !cmr
+    allocate(pcf%wc(beg:end)) !cmr
+    allocate(pcf%we(beg:end)) !cmr
+    allocate(pcf%wjsun(beg:end)) !cmr
+    allocate(pcf%wcsun(beg:end)) !cmr
+    allocate(pcf%wesun(beg:end)) !cmr
+    allocate(pcf%wjsha(beg:end)) !cmr
+    allocate(pcf%wcsha(beg:end)) !cmr
+    allocate(pcf%wesha(beg:end)) !cmr
 
     allocate(pcf%m_leafc_to_litter(beg:end))
     allocate(pcf%m_frootc_to_litter(beg:end))
@@ -8522,7 +8782,30 @@
     pcf%psnsun(beg:end) = nan
     pcf%psnsha(beg:end) = nan
     pcf%fpsn(beg:end) = nan
-    pcf%fco2(beg:end) = 0._r8
+    pcf%psnsun2(beg:end) = nan !cmr
+    pcf%psnsun3(beg:end) = nan !cmr
+    pcf%psnsun4(beg:end) = nan !cmr
+    pcf%psnsha2(beg:end) = nan !cmr
+    pcf%psnsha3(beg:end) = nan !cmr
+    pcf%psnsha4(beg:end) = nan !cmr
+    pcf%fpsn_mn(beg:end) = nan !cmr
+    pcf%fpsn_mx(beg:end) = nan !cmr
+    pcf%fpsn_nf(beg:end) = nan !cmr
+    pcf%fpsn_noslp(beg:end) = nan !cmr
+!    pcf%fco2(beg:end) = 0._r8
+    pcf%reco(beg:end) = 0._r8 !cmr
+    pcf%reco_gpp(beg:end) = 0._r8 !cmr
+    pcf%reco_gppmn(beg:end) = 0._r8 !cmr
+    pcf%reco_gppmx(beg:end) = 0._r8 !cmr
+    pcf%wj(beg:end) = 0._r8 !cmr
+    pcf%we(beg:end) = 0._r8 !cmr
+    pcf%wc(beg:end) = 0._r8 !cmr
+    pcf%wjsun(beg:end) = 0._r8 !cmr
+    pcf%wesun(beg:end) = 0._r8 !cmr
+    pcf%wcsun(beg:end) = 0._r8 !cmr
+    pcf%wjsha(beg:end) = 0._r8 !cmr
+    pcf%wesha(beg:end) = 0._r8 !cmr
+    pcf%wcsha(beg:end) = 0._r8 !cmr
 
     pcf%m_leafc_to_litter(beg:end) = nan
     pcf%m_frootc_to_litter(beg:end) = nan
@@ -11326,6 +11609,7 @@
     deallocate(pps%dewmx )
     deallocate(pps%rssun )
     deallocate(pps%rssha )
+    deallocate(pps%rs_mr ) !cmr
     deallocate(pps%laisun )
     deallocate(pps%laisha )
     deallocate(pps%btran )
@@ -11401,6 +11685,14 @@
     ! Adding isotope code
     deallocate(pps%cisun )
     deallocate(pps%cisha )
+    deallocate(pps%ci_mr ) !cmr
+    deallocate(pps%rb_mr ) !cmr
+    deallocate(pps%btran_mr ) !cmr
+    deallocate(pps%apar_mr ) !cmr
+    deallocate(pps%sla_mr ) !cmr
+    deallocate(pps%vcmx_mr ) !cmr
+    deallocate(pps%svpts_mr ) !cmr
+    deallocate(pps%eah_mr ) !cmr
 #if (defined C13)
     deallocate(pps%alphapsnsun )
     deallocate(pps%alphapsnsha )
@@ -11998,7 +12290,30 @@
     deallocate(pcf%psnsun )
     deallocate(pcf%psnsha )  
     deallocate(pcf%fpsn )
-    deallocate(pcf%fco2 )
+    deallocate(pcf%psnsun2 ) !cmr
+    deallocate(pcf%psnsun3 ) !cmr
+    deallocate(pcf%psnsun4 ) !cmr
+    deallocate(pcf%psnsha2 ) !cmr
+    deallocate(pcf%psnsha3 ) !cmr  
+    deallocate(pcf%psnsha4 ) !cmr  
+    deallocate(pcf%fpsn_mn ) !cmr
+    deallocate(pcf%fpsn_mx ) !cmr
+    deallocate(pcf%fpsn_nf ) !cmr
+    deallocate(pcf%fpsn_noslp )!cmr
+!    deallocate(pcf%fco2 )
+    deallocate(pcf%reco ) !cmr
+    deallocate(pcf%reco_gpp ) !cmr
+    deallocate(pcf%reco_gppmn ) !cmr
+    deallocate(pcf%reco_gppmx ) !cmr
+    deallocate(pcf%wj ) !cmr
+    deallocate(pcf%we ) !cmr
+    deallocate(pcf%wc ) !cmr
+    deallocate(pcf%wjsun ) !cmr
+    deallocate(pcf%wesun ) !cmr
+    deallocate(pcf%wcsun ) !cmr
+    deallocate(pcf%wjsha ) !cmr
+    deallocate(pcf%wesha ) !cmr
+    deallocate(pcf%wcsha ) !cmr
 
     deallocate(pcf%m_leafc_to_litter )
     deallocate(pcf%m_frootc_to_litter )
@@ -17865,11 +18180,10 @@
       mss_frc_cly_vld(c) = min(clay*0.01_r8, 0.20_r8)
 
    end do
-
-
-    call CLMDebug('mark3')
+   call CLMDebug('mark3')
    ! pft level initialization
-   do p = begp, endp
+   
+      do p = begp, endp
 
       ! Initialize maximum allowed dew
 
@@ -23684,6 +23998,9 @@
     real(r8) :: rmax                                     ! maximum patch cover
 !ylu 01/16/2009
     integer  :: pftid
+ 
+    character*254 :: msg !cmr 
+  
 !!-------------------------------------------------------------------------
        ! Initialize surface data to fill value
   call CLMDebug('surfrd-mark1')
@@ -23731,6 +24048,7 @@
 
           call CLMDebug('surfrd-mark2')
 
+
 !---------------------------------------------------
 ! in current versions of CLM, the lake scheme has problems 
 ! in simulating deep lakes. Esepcially, observed lake depth data should
@@ -23746,10 +24064,11 @@
 !              pctgla(g)      = 100.0
 !           end if
 !----------------------------------------------------
-           do m=1,maxpatch_pft
-               pft(g,m) = plant(iveg,m)
+!cmrpft: one can set pft here manually 
+          do m=1,maxpatch_pft
+               pft(g,m) =  plant(iveg,m)
                if(cover(iveg,m).ne.0.0) then
-                pctpft(g,pft(g,m)) = cover(iveg,m)
+                  pctpft(g,pft(g,m)) = cover(iveg,m)
                end if
            end do
 
@@ -23764,6 +24083,7 @@
 !---------------------------------------------------------------------
          end do
            call CLMDebug('surfrd--mark3')
+
        ! Error check: valid PFTs and sum of cover must equal 100
 
 #ifndef DGVM
@@ -25586,6 +25906,7 @@
 
 !-----------------------------------------------------------------------
 
+  character(256) :: msg
   ! Assign local pointers to derived subtypes components (landunit-level)
 
   ltype => clm3%g%l%itype
@@ -31739,7 +32060,7 @@
     real(r8) :: voleq1                      ! temp variable for calculating vol_eq
     real(r8) :: zwtmm(lbc:ubc)              ! water table depth [mm]
 !-----------------------------------------------------------------------
-
+    character*256 :: msg !cmrwrite
     ! Assign local pointers to derived type members (column-level)
 
     qcharge           => clm3%g%l%c%cws%qcharge
